*** QL-SD Driver basic interface

	section procs

	xdef	win_drive
	xdef	win_use
	xdef	card_init

	include dev8_keys_sys
	include dev8_keys_err
	include dev8_keys_qlv
	include dev8_mac_assert
	include DEV8_dv3_keys
	include DEV8_dv3_hd_keys
	include 'dev8_keys_iod'

	xref	norm_nm
	xref	gu_achpp
	xref	gu_rchp
	xref	dv3_close
	xref	inicrd
	xref	get_str

; *********
; WIN_DRIVE x,"name"
; *********

errbp	moveq	#err.ipar,d0
exit	rts
win_drive
	subq.l	#8,a5
	move.w	sb.gtint,a2
	jsr	(a2)
	bne.s	exit			; get int
	subq.w	#1,d3
	bne.s	errbp
	addq.l	#2,$58(a6)
	move.w	(a6,a1.l),d7		; drive nbr
	move.w	d7,d5
	subq.w	#1,d5
	blt.s	errbp
	cmp.w	#7,d5
	bgt.s	errbp			; must be 1...8
	addq.l	#8,a3
	bsr	get_str 		; get string
	bne.s	errbp			;
	bsr.s	srch
	bne.s	exit
	move.l	a0,a5
	lea	hdl_end-ddl_ddlk(a4),a0 ; pointer to names
	lsl.w	#4,d5
	add.w	d5,a0
	move.w	sr,d0
	trap	#0
	move.w	d0,-(a7)
	add.l	a6,a1
	move.l	a6,-(a7)
	exg	a0,a1
	bsr	norm_nm 		; normalise name & set it
	bne.s	wd_err			; ooops, wrong name
	move.l	a4,a3
	move.l	a5,a6			; we need a6 later in subroutine
; find corresponding drive definition block
	lea	sys_fsdd(a6),a2
	moveq	#$f,d0			; there is space for 16 drive defn blcks
wd_fdrv move.l	(a2)+,a4		: next drv defn blk
	cmp.l	ddf_ddlk(a4),a3 	; our driver?
	bne.s	wd_next 		; ... no
	cmp.b	ddf_dnum(a4),d7 	; our drive?
	bne.s	wd_next 		; ... no
	bsr	del_blk 		; ... yes, close chans, del block
	bra.s	wd_out			; and we're done
wd_next dbf	d0,wd_fdrv		; try all drive defn blks

wd_out	moveq	#0,d0
wd_err	move.l	(a7)+,a6
	move.w	(a7)+,sr
	tst.l	d0
	rts

; srch subroutine : find my device driver linkage block
; d0  s is NOT error
; d1  s
; a0  r sysvars
; a4  r my linkage block
;
; on return cond codes : EQ = found block, NE = not found
; D0 is NOT error / no error code

srch	moveq	#0,d0
	trap	#1
	move.l	#'WIN0',d1
chk_dev lea	sys_fsdl(a0),a4 	; device list
srch_lp move.l	(a4),d0 		; is there another device?
	beq.s	not_fnd 		; no, leave with error ->
	move.l	d0,a4			; this is the device
	cmp.l	$2c(a4),d1
	beq.s	done
	bra.s	srch_lp

not_fnd moveq	#err.fdnf,d0		; yes, leave with "in use"
done	rts

;***********************
;
; WIN_USE device (three letter name)
;
;***********************

win_use bsr.s	srch
	bne.s	done
	move.l	#$57494e00,d0		; preset "WIN"
	cmp.l	a5,a3			; any string?
	beq.s	wu_set			; no, use WIN
	bsr	get_str
	bne.s	not_fnd
	move.l	2(a6,a1.l),d0
	andi.l	#$dfdfdf00,d0
wu_set	move.l	d0,$26(a4)
	clr.l	d0
	rts

; ************************************
;
; CARD_INIT
;
; ************************************
card_init
	bsr.s	srch
	bne.s	done
	move.l	a4,a3			; point dev drv linkage block
; first go super
	move.w	sr,d0
	trap	#0
	move.w	d0,-(a7)
	move.l	a6,-(a7)
	move.l	a0,a6
; try to find a drive definition that points to this device
; and delete it and close all channels open to it
	lea	sys_fsdd(a6),a2
	moveq	#$f,d7			; there are 16 drv defn blks
ddb_lp	move.l	(a2)+,d0		; check another drv defn block
	beq.s	ddb_do			; there is none here
	move.l	d0,a4
	cmp.l	ddf_ddlk(a4),a3 	; is this a drive on my device?
	bne.s	ddb_do			; ... no
	bsr.s	del_blk 		; yes, close all chans, delete blk
ddb_do	dbf	d7,ddb_lp		; try next drive
	move.l	(a7)+,a6
	move.w	(a7)+,sr
	jmp	inicrd			; try to init card

del_blk
; as of here, a4 = drive defn block, -4(a2) = entry in defn block table
; close all channels to this defn blk and then delete and release it
chkchn	move.l	a2,d6			; keep this
	move.l	sys_chtb(a6),a5 	; point to first channel
	move.l	sys_chtt(a6),d2
ch_lp1	move.l	(a5)+,d0
	bmi.s	ch_next 		; channel is closed
	move.l	d0,a0
	assert	d3c_flid,d3c_drid-4,d3c_drnr-6,d3c_ddef-8
	cmp.l	d3c_ddef(a0),a4 	; is this a channel to this defn blk ?
	bne.s	ch_next 		; no
	move.b	#d3c.asect,d3c_atype(a0); yes, pretend this is a direct sector access channel
	jsr	dv3_close		; close this channel now
ch_next cmp.l	d2,a5			; continue, unless we're done with all channels
	blt.s	ch_lp1
; delete and release drive defn block
	move.l	d6,a2
	move.l	a4,a0
	clr.l	-4(a2)			; clear pointer = delete block in tble
	movem.l d3/a1-a3/a6,-(a7)
	move.w	mem.rchp,a2		; release this block
	jsr	(a2)
	movem.l (a7)+,d3/a1-a3/a6
	rts

	end
