; DV3 SDHC Write Sector for Q68  0.00	 2016 W. Lenerz
; based on

; DV3 QXL Hard Disk Read Sector      1993     Tony Tebby
; 2006.10.20	1.01	BLAT macro definitions commented out - macro wasn't used (wl)


	section dv3

	xdef	hd_wdirect		; direct write sector
	xdef	hd_wsint		; internal write sector

	xref	hd_hold 		; reserve the interface
	xref	hd_release		; release the interface
	xref	snd_cmd 		; send a command to sdhc


	include 'dev8_keys_java'
	include 'DEV8_dv3_keys'
	include 'DEV8_keys_err'
	include 'DEV8_dv3_hd_keys'
	include 'dev1_q68_qlsd_keys'

sendreg reg	d1-d4/d7/a1/a2/a3


;+++
; This routine writes a sector to an sdhc card, normally for direct sector I/O.
;+++
;hd_wdirect
;	 tst.w	 ddf_ftype(a4)		 ; really direct sector I/O?
;	 bge.s	 hd_wsint		 ; no
;	 add.l	 ddf_psoff(a4),d0	 ; yes, add "partition start"
;	 bra.s	 hd_wsint
;+++
; This routine writes a sector to a sdhc card via background transfer.
;
;	d0 cr	sector number / error code
;	d2 c  p number of sectors (at least 1!)
;	d7 c  p drive ID / number  (from 0 to 7)
;	a1 c  p address to read from
;	a3 c  p linkage block
;	a4 c  p drive definition
;
;	status return 0 or ERR.TRNS
;
;	The sector number is for sectors 512 bytes long. The interface needs
;	the sector (or "block") number.
;---

hdw_inus
	rts
hd_wdirect
hd_wsint
	jsr	hd_hold 		; hold the drive for me
	bne	hdw_inus		; can't
	movem.l sendreg,-(a7)
	move.l	#IF_BASE,a2
	tst.b	SPI_SELECT1(a2) 	; select the card

	add.l	ddf_dtop-4(a4),d0
	move.l	d0,d7			; address to read from
	subq.w	#1,d2			; prepare for dbf

; first send command24	($58) to the card
; ($58, 4 bytes with the address to read from, $ff)
wrtloop move.l	d7,d0
	moveq	#-1,d1
	move.b	d0,d1
	rol.w	#8,d1			; d1.w = last byte of address , $ff
	move.b	#$58,d0
	ror.l	#8,d0			; $58 and first 3 bytes of address
	bsr	snd_cmd 		; send command now
	bne.s	hdw_dis 		; ooops
	tst.b	d1			; return needs to be 0
	bne.s	hdw_dis 		; ooops again
			  
	move.l	#SPI_BG_READ,a3
	moveq	#100,d3
waitlp1 tst.b	(a3)
	tst.b	SPI_READ(a2)		; send some clocks to card
	dbf	d3,waitlp1
	 
	move.l	#SPI_XFER,a3
	tst.b	$fe(a3) 		; send start block write token
	clr.l	d1

; now write 512 times one byte
	move.w	#511,d3 		; for 512 bytes
sendlp	move.b	(a1)+,d1
	tst.b	(a3,d1.w)
	dbf	d3,sendlp		; do it for 512 bytes
		
	tst.b	$ff(a3) 		;
	tst.b	$ff(a3) 		; send 2 dummy CRCs

; wait for not busy reply from card
	move.l	#SPI_BG_READ,a3
	move.w	#5000,d3
waitlp2 tst.b	(a3)			; prep for transfer
	cmp.b	#$ff,SPI_READ(a2)	; get byte, check for $ff
	beq.s	next			; card is ok
	dbf	d3,waitlp2		; no, wait until you get this back
	bra.s	hdw_err 		; card has pbs

next	addq.l	#1,d7			; next sector to read
	dbf	d2,wrtloop
	moveq	#0,d0			; done and ok
hdw_dis tst.b	SPI_SELECT0(a2) 	; disable the card
hdw_out movem.l (a7)+,sendreg
	tst.l	d0
	jmp	hd_release		; release & return
hdw_err
	moveq	#err.mchk,d0
	bra.s	hdw_dis

	end
